AuthProvider (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.security, class: AuthProvider
Keywords: java.security.AuthProvider class

# Class AuthProvider

java.lang.Object
java.util.Dictionary<Object,Object>
java.util.Hashtable<Object,Object>
java.util.Properties
java.security.Provider
java.security.AuthProvider

All Implemented Interfaces:
  `Serializable, Cloneable, Map<Object,Object>`

public abstract class AuthProvider extends Provider
This class defines login and logout methods for a provider.

While callers may invoke `login` directly, the provider may also invoke `login` on behalf of callers if it determines that a login must be performed prior to certain operations.

Since:
  1.5
See Also:
  - Serialized Form

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Provider

  `Provider.Service`
  Modifier and Type
  Class
  Description
  `static class`
  `Provider.Service`
  The description of a security service.

- ## Field Summary

  ### Fields declared in class Properties

  `defaults`
  Modifier and Type
  Field
  Description
  `protected Properties`
  `defaults`
  A property list that contains default values for any keys not found in this property list.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AuthProvider(String name, double version, String info)`
  Deprecated.
  use `AuthProvider(String, String, String)` instead.
  `protected`
  `AuthProvider(String name, String versionStr, String info)`
  Constructs a provider with the specified name, version string, and information.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract void`
  `login(Subject subject, CallbackHandler handler)`
  Log in to this provider.
  `abstract void`
  `logout()`
  Log out from this provider.
  `abstract void`
  `setCallbackHandler(CallbackHandler handler)`
  Set a `CallbackHandler`.

  ### Methods declared in class Provider

  `clear, compute, computeIfAbsent, computeIfPresent, configure, entrySet, forEach, getInfo, getName, getOrDefault, getService, getServices, getVersion, getVersionStr, isConfigured, keySet, load, merge, put, putAll, putIfAbsent, putService, remove, remove, removeService, replace, replace, replaceAll, toString, values`
  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Clears this `Provider` so that it no longer contains the properties used to look up facilities implemented by the `Provider`.
  `Object`
  `compute(Object key, BiFunction<? super Object, ? super Object, ? extends Object> remappingFunction)`
  Attempts to compute a mapping for the specified key and its current mapped value (or `null` if there is no current mapping).
  `Object`
  `computeIfAbsent(Object key, Function<? super Object, ? extends Object> mappingFunction)`
  If the specified key is not already associated with a value (or is mapped to `null`), attempts to compute its value using the given mapping function and enters it into this map unless `null`.
  `Object`
  `computeIfPresent(Object key, BiFunction<? super Object, ? super Object, ? extends Object> remappingFunction)`
  If the value for the specified key is present and non-null, attempts to compute a new mapping given the key and its current mapped value.
  `Provider`
  `configure(String configArg)`
  Apply the supplied configuration argument to this `Provider` instance and return the configured `Provider`.
  `Set<Map.Entry<Object,Object>>`
  `entrySet()`
  Returns an unmodifiable Set view of the property entries contained in this `Provider`.
  `void`
  `forEach(BiConsumer<? super Object, ? super Object> action)`
  Performs the given action for each entry in this map until all entries have been processed or the action throws an exception.
  `String`
  `getInfo()`
  Returns a human-readable description of the `Provider` and its services.
  `String`
  `getName()`
  Returns the name of this `Provider`.
  `Object`
  `getOrDefault(Object key, Object defaultValue)`
  Returns the value to which the specified key is mapped, or `defaultValue` if this map contains no mapping for the key.
  `Provider.Service`
  `getService(String type, String algorithm)`
  Get the service describing this Provider's implementation of the specified type of this algorithm or alias.
  `Set<Provider.Service>`
  `getServices()`
  Get an unmodifiable Set of all services supported by this `Provider`.
  `double`
  `getVersion()`
  Deprecated.
  use `Provider.getVersionStr()` instead.
  `String`
  `getVersionStr()`
  Returns the version string for this `Provider`.
  `boolean`
  `isConfigured()`
  Check if this `Provider` instance has been configured.
  `Set<Object>`
  `keySet()`
  Returns an unmodifiable Set view of the property keys contained in this `Provider`.
  `void`
  `load(InputStream inStream)`
  Reads a property list (key and element pairs) from the input stream.
  `Object`
  `merge(Object key, Object value, BiFunction<? super Object, ? super Object, ? extends Object> remappingFunction)`
  If the specified key is not already associated with a value or is associated with `null`, associates it with the given value.
  `Object`
  `put(Object key, Object value)`
  Sets the `key` property to have the specified `value`.
  `void`
  `putAll(Map<?,?> t)`
  Copies all the mappings from the specified Map to this `Provider`.
  `Object`
  `putIfAbsent(Object key, Object value)`
  If the specified key is not already associated with a value (or is mapped to `null`) associates it with the given value and returns `null`, else returns the current value.
  `protected void`
  `putService(Provider.Service s)`
  Add a service.
  `Object`
  `remove(Object key)`
  Removes the `key` property (and its corresponding `value`).
  `boolean`
  `remove(Object key, Object value)`
  Removes the entry for the specified key only if it is currently mapped to the specified value.
  `protected void`
  `removeService(Provider.Service s)`
  Remove a service previously added using `putService()`.
  `Object`
  `replace(Object key, Object value)`
  Replaces the entry for the specified key only if it is currently mapped to some value.
  `boolean`
  `replace(Object key, Object oldValue, Object newValue)`
  Replaces the entry for the specified key only if currently mapped to the specified value.
  `void`
  `replaceAll(BiFunction<? super Object, ? super Object, ? extends Object> function)`
  Replaces each entry's value with the result of invoking the given function on that entry, in the order entries are returned by an entry set iterator, until all entries have been processed or the function throws an exception.
  `String`
  `toString()`
  Returns a string with the name and the version string of this `Provider`.
  `Collection<Object>`
  `values()`
  Returns an unmodifiable Collection view of the property values contained in this `Provider`.

  ### Methods declared in class Properties

  `getProperty, getProperty, list, list, load, loadFromXML, propertyNames, save, setProperty, store, store, storeToXML, storeToXML, storeToXML, stringPropertyNames`
  Modifier and Type
  Method
  Description
  `String`
  `getProperty(String key)`
  Searches for the property with the specified key in this property list.
  `String`
  `getProperty(String key, String defaultValue)`
  Searches for the property with the specified key in this property list.
  `void`
  `list(PrintStream out)`
  Prints this property list out to the specified output stream.
  `void`
  `list(PrintWriter out)`
  Prints this property list out to the specified output stream.
  `void`
  `load(Reader reader)`
  Reads a property list (key and element pairs) from the input character stream in a simple line-oriented format.
  `void`
  `loadFromXML(InputStream in)`
  Loads all of the properties represented by the XML document on the specified input stream into this properties table.
  `Enumeration<?>`
  `propertyNames()`
  Returns an enumeration of all the keys in this property list, including distinct keys in the default property list if a key of the same name has not already been found from the main properties list.
  `void`
  `save(OutputStream out, String comments)`
  Deprecated.
  This method does not throw an IOException if an I/O error occurs while saving the property list.
  `Object`
  `setProperty(String key, String value)`
  Calls the `Hashtable` method `put`.
  `void`
  `store(OutputStream out, String comments)`
  Writes this property list (key and element pairs) in this `Properties` table to the output stream in a format suitable for loading into a `Properties` table using the `load(InputStream)` method.
  `void`
  `store(Writer writer, String comments)`
  Writes this property list (key and element pairs) in this `Properties` table to the output character stream in a format suitable for using the `load(Reader)` method.
  `void`
  `storeToXML(OutputStream os, String comment)`
  Emits an XML document representing all of the properties contained in this table.
  `void`
  `storeToXML(OutputStream os, String comment, String encoding)`
  Emits an XML document representing all of the properties contained in this table, using the specified encoding.
  `void`
  `storeToXML(OutputStream os, String comment, Charset charset)`
  Emits an XML document representing all of the properties contained in this table, using the specified encoding.
  `Set<String>`
  `stringPropertyNames()`
  Returns an unmodifiable set of keys from this property list where the key and its corresponding value are strings, including distinct keys in the default property list if a key of the same name has not already been found from the main properties list.

  ### Methods declared in class Hashtable

  `clone, contains, containsKey, containsValue, elements, equals, get, hashCode, isEmpty, keys, rehash, size`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a shallow copy of this hashtable.
  `boolean`
  `contains(Object value)`
  Tests if some key maps into the specified value in this hashtable.
  `boolean`
  `containsKey(Object key)`
  Tests if the specified object is a key in this hashtable.
  `boolean`
  `containsValue(Object value)`
  Returns true if this hashtable maps one or more keys to this value.
  `Enumeration<Object>`
  `elements()`
  Returns an enumeration of the values in this hashtable.
  `boolean`
  `equals(Object o)`
  Compares the specified Object with this Map for equality, as per the definition in the Map interface.
  `Object`
  `get(Object key)`
  Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.
  `int`
  `hashCode()`
  Returns the hash code value for this Map as per the definition in the Map interface.
  `boolean`
  `isEmpty()`
  Tests if this hashtable maps no keys to values.
  `Enumeration<Object>`
  `keys()`
  Returns an enumeration of the keys in this hashtable.
  `protected void`
  `rehash()`
  Increases the capacity of and internally reorganizes this hashtable, in order to accommodate and access its entries more efficiently.
  `int`
  `size()`
  Returns the number of keys in this hashtable.

  ### Methods declared in class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### AuthProvider

    @Deprecated(since="9") protected AuthProvider(String name, double version, String info)
    Deprecated.
    use `AuthProvider(String, String, String)` instead.
    Constructs a provider with the specified name, version number, and information.
    Parameters:
      `name` - the provider name.
      `version` - the provider version number.
      `info` - a description of the provider and its services.

  - ### AuthProvider

    protected AuthProvider(String name, String versionStr, String info)
    Constructs a provider with the specified name, version string, and information.
    Parameters:
      `name` - the provider name.
      `versionStr` - the provider version string.
      `info` - a description of the provider and its services.
    Since:
      9

- ## Method Details

  - ### login

    public abstract void login(Subject subject, CallbackHandler handler) throws LoginException
    Log in to this provider.

    The provider relies on a `CallbackHandler` to obtain authentication information from the caller (a PIN, for example). If the caller passes a `null` handler to this method, the provider uses the handler set in the `setCallbackHandler` method. If no handler was set in that method, the provider queries the auth.login.defaultCallbackHandler security property for the fully qualified class name of a default handler implementation. If the security property is not set, the provider is assumed to have alternative means for obtaining authentication information.

    Parameters:
      `subject` - the `Subject` which may contain principals/credentials used for authentication, or may be populated with additional principals/credentials after successful authentication has completed. This parameter may be `null`.
      `handler` - the `CallbackHandler` used by this provider to obtain authentication information from the caller, which may be `null`
    Throws:
      `IllegalStateException` - if the provider requires configuration and `Provider.configure(String)` has not been called
      `LoginException` - if the login operation fails

  - ### logout

    public abstract void logout() throws LoginException
    Log out from this provider.
    Throws:
      `IllegalStateException` - if the provider requires configuration and `Provider.configure(String)` has not been called
      `LoginException` - if the logout operation fails

  - ### setCallbackHandler

    public abstract void setCallbackHandler(CallbackHandler handler)
    Set a `CallbackHandler`.

    The provider uses this handler if one is not passed to the `login` method. The provider also uses this handler if it invokes `login` on behalf of callers. In either case if a handler is not set via this method, the provider queries the auth.login.defaultCallbackHandler security property for the fully qualified class name of a default handler implementation. If the security property is not set, the provider is assumed to have alternative means for obtaining authentication information.

    Parameters:
      `handler` - a `CallbackHandler` for obtaining authentication information, which may be `null`
    Throws:
      `IllegalStateException` - if the provider requires configuration and `Provider.configure(String)` has not been called